"""empty message

Revision ID: 40964e5a022
Revises: None
Create Date: 2016-02-01 17:29:17.477759

"""

# revision identifiers, used by Alembic.
revision = '40964e5a022'
down_revision = None

from alembic import op
import sqlalchemy as sa
from sqlalchemy.dialects import postgresql

def upgrade():
    ### commands auto generated by Alembic - please adjust! ###
    op.create_table('api_call',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('url', sa.String(), nullable=True),
    sa.Column('size', sa.Integer(), nullable=True),
    sa.Column('status', sa.Integer(), nullable=True),
    sa.Column('error', sa.String(), nullable=True),
    sa.Column('source', sa.Enum('Nextbus', name='source', native_enum=False), nullable=True),
    sa.Column('time', sa.DateTime(), nullable=True),
    sa.Column('params', postgresql.JSON(), nullable=True),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('region',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('title', sa.String(), nullable=True),
    sa.Column('api_call_id', sa.Integer(), nullable=True),
    sa.ForeignKeyConstraint(['api_call_id'], ['api_call.id'], ondelete='set null'),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_index(op.f('ix_region_title'), 'region', ['title'], unique=True)
    op.create_table('stop',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('stop_id', sa.Integer(), nullable=True),
    sa.Column('title', sa.String(), nullable=True),
    sa.Column('lat', sa.Float(), nullable=True),
    sa.Column('lon', sa.Float(), nullable=True),
    sa.Column('lat_lon_count', sa.Integer(), nullable=True),
    sa.Column('api_call_id', sa.Integer(), nullable=True),
    sa.ForeignKeyConstraint(['api_call_id'], ['api_call.id'], ondelete='set null'),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('title', 'lat', 'lon')
    )
    op.create_table('agency',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('tag', sa.String(), nullable=True),
    sa.Column('title', sa.String(), nullable=True),
    sa.Column('short_title', sa.String(), nullable=True),
    sa.Column('region_id', sa.Integer(), nullable=False),
    sa.Column('api_call_id', sa.Integer(), nullable=True),
    sa.ForeignKeyConstraint(['api_call_id'], ['api_call.id'], ondelete='set null'),
    sa.ForeignKeyConstraint(['region_id'], ['region.id'], ondelete='cascade'),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('tag')
    )
    op.create_table('route',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('agency_id', sa.Integer(), nullable=False),
    sa.Column('tag', sa.String(), nullable=True),
    sa.Column('title', sa.String(), nullable=True),
    sa.Column('short_title', sa.String(), nullable=True),
    sa.Column('color', sa.String(), nullable=True),
    sa.Column('opposite_color', sa.String(), nullable=True),
    sa.Column('lat_min', sa.Float(), nullable=True),
    sa.Column('lat_max', sa.Float(), nullable=True),
    sa.Column('lon_min', sa.Float(), nullable=True),
    sa.Column('lon_max', sa.Float(), nullable=True),
    sa.Column('api_call_id', sa.Integer(), nullable=True),
    sa.ForeignKeyConstraint(['agency_id'], ['agency.id'], ondelete='cascade'),
    sa.ForeignKeyConstraint(['api_call_id'], ['api_call.id'], ondelete='set null'),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('tag', 'agency_id')
    )
    op.create_table('direction',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('route_id', sa.Integer(), nullable=False),
    sa.Column('tag', sa.String(), nullable=True),
    sa.Column('title', sa.String(), nullable=True),
    sa.Column('name', sa.String(), nullable=True),
    sa.Column('api_call_id', sa.Integer(), nullable=True),
    sa.ForeignKeyConstraint(['api_call_id'], ['api_call.id'], ondelete='set null'),
    sa.ForeignKeyConstraint(['route_id'], ['route.id'], ondelete='cascade'),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('tag', 'route_id')
    )
    op.create_table('route_stop',
    sa.Column('route_id', sa.Integer(), nullable=False),
    sa.Column('stop_id', sa.Integer(), nullable=False),
    sa.Column('stop_tag', sa.String(), nullable=False),
    sa.ForeignKeyConstraint(['route_id'], ['route.id'], ondelete='cascade'),
    sa.ForeignKeyConstraint(['stop_id'], ['stop.id'], ondelete='cascade'),
    sa.PrimaryKeyConstraint('route_id', 'stop_id')
    )
    op.create_table('prediction',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('route_id', sa.Integer(), nullable=False),
    sa.Column('prediction', sa.DateTime(), nullable=True),
    sa.Column('created', sa.DateTime(), nullable=True),
    sa.Column('is_departure', sa.Boolean(), nullable=True),
    sa.Column('has_layover', sa.Boolean(), nullable=True),
    sa.Column('direction_id', sa.Integer(), nullable=False),
    sa.Column('vehicle', sa.String(), nullable=True),
    sa.Column('block', sa.String(), nullable=True),
    sa.Column('stop_id', sa.Integer(), nullable=True),
    sa.Column('api_call_id', sa.Integer(), nullable=True),
    sa.ForeignKeyConstraint(['api_call_id'], ['api_call.id'], ondelete='set null'),
    sa.ForeignKeyConstraint(['direction_id'], ['direction.id'], ondelete='cascade'),
    sa.ForeignKeyConstraint(['route_id'], ['route.id'], ondelete='cascade'),
    sa.ForeignKeyConstraint(['stop_id'], ['stop.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('vehicle_location',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('vehicle', sa.String(), nullable=True),
    sa.Column('route_id', sa.Integer(), nullable=False),
    sa.Column('direction_id', sa.Integer(), nullable=True),
    sa.Column('lat', sa.Float(), nullable=True),
    sa.Column('lon', sa.Float(), nullable=True),
    sa.Column('time', sa.DateTime(), nullable=True),
    sa.Column('predictable', sa.Boolean(), nullable=True),
    sa.Column('heading', sa.Integer(), nullable=True),
    sa.Column('speed', sa.Float(), nullable=True),
    sa.Column('api_call_id', sa.Integer(), nullable=True),
    sa.ForeignKeyConstraint(['api_call_id'], ['api_call.id'], ondelete='set null'),
    sa.ForeignKeyConstraint(['direction_id'], ['direction.id'], ondelete='cascade'),
    sa.ForeignKeyConstraint(['route_id'], ['route.id'], ondelete='cascade'),
    sa.PrimaryKeyConstraint('id')
    )
    ### end Alembic commands ###


def downgrade():
    ### commands auto generated by Alembic - please adjust! ###
    op.drop_table('vehicle_location')
    op.drop_table('prediction')
    op.drop_table('route_stop')
    op.drop_table('direction')
    op.drop_table('route')
    op.drop_table('agency')
    op.drop_table('stop')
    op.drop_index(op.f('ix_region_title'), table_name='region')
    op.drop_table('region')
    op.drop_table('api_call')
    ### end Alembic commands ###
